"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("./utils");
/**
 * Created by richard.g on 20/05/2017.
 */
var JSONObserver = (function () {
    function JSONObserver(data, callback) {
        this.entrance(data, callback);
    }
    JSONObserver.prototype.entrance = function (data, callback) {
        if (callback === void 0) { callback = function () {
        }; }
        if (Array.isArray(data)) {
            this.setArray(data, callback);
        }
        else if (utils_1.utils.isObject(data)) {
            this.setProp(data, callback);
        }
    };
    JSONObserver.prototype.setArray = function (arr, callback) {
        var _this = this;
        arr.forEach(function (exactlyData, key, data) {
            if (utils_1.utils.isPrimaryData(exactlyData)) {
                _this.observer(data, key, callback);
            }
            else if (utils_1.utils.isObject(exactlyData)) {
                _this.entrance(data, callback);
            }
        });
    };
    JSONObserver.prototype.setProp = function (data, callback) {
        for (var key in data) {
            var exactlyData = data[key];
            if (utils_1.utils.isPrimaryData(exactlyData)) {
                this.observer(data, key, callback);
            }
            else if (utils_1.utils.isObject(exactlyData)) {
                this.entrance(data, callback);
            }
        }
    };
    JSONObserver.prototype.observer = function (data, key, callback) {
        var oldData = data[key];
        var self = this;
        Object.defineProperty(data, key, {
            set: function (x) {
                this.isNew = oldData != x;
                if (this.isNew) {
                    oldData = x;
                    this["_____" + key] = x;
                    if (utils_1.utils.isObject(x) || Array.isArray(data)) {
                        self.entrance(x, callback);
                    }
                    callback(data, oldData, x);
                }
            },
            get: function () {
                return this["_____" + key];
            }
        });
    };
    return JSONObserver;
}());
exports.JSONObserver = JSONObserver;
//# sourceMappingURL=index.js.map