import {utils} from "./utils";
/**
 * Created by richard.g on 20/05/2017.
 */

export class JSONObserver {
    constructor(data, callback) {
        this.entrance(data, callback)
    }

    entrance(data: any, callback: Function = () => {
    }) {
        if (Array.isArray(data)) {
            this.setArray(data, callback);
        } else if (utils.isObject(data)) {
            this.setProp(data, callback)
        }
    }

    setArray(arr: Array<any>, callback: Function) {
        arr.forEach((exactlyData, key, data) => {
            if (utils.isPrimaryData(exactlyData)) {
                this.observer(data, key, callback);
            } else if (utils.isObject(exactlyData)) {
                this.entrance(data, callback)
            }
        });
    }

    setProp(data, callback: Function) {
        for (let key in data) {
            let exactlyData = data[key];
            if (utils.isPrimaryData(exactlyData)) {
                this.observer(data, key, callback);
            } else if (utils.isObject(exactlyData)) {
                this.entrance(data, callback)
            }
        }
    }

    observer(data, key, callback: Function) {
        let oldData = data[key];
        let self = this;
        Object.defineProperty(data, key, {
            set: function (x) {
                this.isNew = oldData != x;

                if (this.isNew) {
                    oldData = x;
                    this[`_____${key}`] = x;

                    if (utils.isObject(x) || Array.isArray(data)) {
                        self.entrance(x, callback);
                    }
                    
                    callback(data,oldData,x);
                }
            },
            get: function () {
                return this[`_____${key}`];
            }
        });
    }
}

