/**
 * Created by richard.g on 21/05/2017.
 */

let {JSONObserver} = require('../index');
var assert = require("assert");

describe('Observer', function () {
    describe('#new JSONObserver()', function () {
        it('should callback invoke when the Object changed', function () {
            let obj = {
                a: '',
                b: ''
            };
            let index = 0;
            let hander1 = function () {
                ++index;
            };
            new JSONObserver(obj, hander1);

            obj.a = 'a';
            assert.equal(1, index);
            obj.a = {bbb: ''}

            assert.equal(2, index);

            obj.a.bbb = 'kklfslf'
            assert.equal(3, index);
        });
        it('should callback invoke when the array changed', function () {
            let obj = [1, 2, 3];
            let index = 0;
            let hander1 = function () {
                ++index;
            };
            new JSONObserver(obj, hander1);
            obj[0] = 'a';
            assert.equal(1, index);
            obj[1] = 20;
            assert.equal(2, index);
            obj[2] = 20;
            assert.equal(3, index);
        });
    });

});
