/**
 * Created by richard.g on 20/05/2017.
 */
let {utils} = require('../utils');
var assert = require("assert");

describe('utils', function () {
    describe('#isPrimaryData()', function () {
        it('should return ture when the value is string,number,null,undefined,boolean', function () {
            assert.equal(true, utils.isPrimaryData('a'));
            assert.equal(true, utils.isPrimaryData(0));
            assert.equal(true, utils.isPrimaryData(null));
            assert.equal(true, utils.isPrimaryData(undefined));
            assert.equal(true, utils.isPrimaryData(true));
        });
        it('should return false when the value is Date,RegEx,Function,Object,Sybmal', function () {
            assert.equal(false, utils.isPrimaryData(new Date()));
            assert.equal(false, utils.isPrimaryData({}));
            assert.equal(false, utils.isPrimaryData(/aa/));
            assert.equal(false, utils.isPrimaryData(function () {
            }));
        });

    });

    describe('#isObject()', function () {
        it('should return false when the value string,number,regex and so on', function () {
            assert.equal(false, utils.isObject(''));
            assert.equal(false, utils.isObject(new String('aaa')));
            assert.equal(false, utils.isObject(/a/));
            assert.equal(false, utils.isObject(0));
        });
        it('should return  when the value literal object,new Object', function () {
            assert.equal(true, utils.isObject({}));
            assert.equal(true, utils.isObject(new Object()));
        });
    });
});
